#include <SI_C8051F360_Register_Enums.h>                // SFR declarations
#include "Project_DefsVarsFuncs.h"

void Delay_us(unsigned int DelayCount)
{
	/*This is accurate only for long delays, because of typical overhead
	 * and the instructions needed to carry out the multiplication.*/

	TMR2CN_TR2 = 0;		//make sure Timer2 is stopped
	TMR2CN_TF2H = 0;		//clear overflow flag
	TMR2 = 0xFFFF - (DelayCount*1.25);	//Timer2 runs at 10MHz/8, one tick = 0.8 us, so counts to overflow = (delay in microseconds)*1.25
	TMR2CN_TR2 = 1;		//start Timer2
	while(!TMR2CN_TF2H);	//wait until overflow flag is set
	TMR2CN_TF2H = 0;	//clear overflow flag
	TMR2CN_TR2 = 0;		//stop Timer2
}

void Delay_10ms(unsigned int DelayCount)
{
	unsigned int n;

	for(n=0; n<DelayCount; n++)
	{
		Delay_us(10000);
	}
}

void Delay_seconds(unsigned int DelayCount)
{
	unsigned int n;

	for(n=0; n<DelayCount; n++)
	{
		Delay_10ms(100);
	}
}

bit Is_In_Range(int input, int LowerBound, int UpperBound)
{
	if(input >= LowerBound && input <= UpperBound)
		return TRUE;

	else
		return FALSE;
}
